<?php

    function libGenerateFilesList($dir){
  
        $arr_filenames = Array();
        $i_filename = 0;
      
        $handle = opendir($dir);
        while ($file = readdir($handle)) {
            if ($file != "." && $file != "..") {
                $arr_filenames[$i_filename] = $file;
                $i_filename++;
            }
        }
        closedir($handle);
      
        return $arr_filenames;
    }
  
    function libGetXLines($source,$num){

        $lines = explode("\n",$source);
        $len = sizeof($lines);  
        if ($len<$num) $num=$len;
        shuffle($lines);  
        $text = "";
        for ($i=0; $i<$num; $i++){      
            $text = $text.$lines[$i]."\n";
        }
        return $text;
    }
  
    //    ,   
    function libRandStrFromFile($path){
        $file = $path;
        $fp = fopen($file,'r');
        flock ($fp,LOCK_EX);
        fseek($fp,rand(0,filesize($file)));
        fgets($fp);
        if(feof($fp)) fseek($fp,0);
        $str = fgets($fp);
        flock ($fp,LOCK_UN);
        fclose($fp);

        return $str;
    }
      
    function libStripTagsCleanAll(
        $s,
        array $allowable_tags = null,
        //array $allowable_tags = array('img','p'),
        $is_format_spaces = false,
        array $pair_tags = array('script', 'style', 'map', 'iframe', 'frameset', 'object', 'applet', 'comment', 'button', 'textarea', 'select'),
        array $para_tags = array('p', 'td', 'th', 'li', 'h1', 'h2', 'h3', 'h4', 'h5', 'h6', 'div', 'form', 'title', 'pre')
    )
    {
        //return strip_tags($s);
        static $_callback_type  = false;
        static $_allowable_tags = array();
        static $_para_tags      = array();
        #regular expression for tag attributes
        #correct processes dirty and broken HTML in a singlebyte or multibyte UTF-8 charset!
        static $re_attrs_fast_safe =  '(?![a-zA-Z\d])  #statement, which follows after a tag
                                       #correct attributes
                                       (?>
                                           [^>"\']+
                                         | (?<=[\=\x20\r\n\t]|\xc2\xa0) "[^"]*"
                                         | (?<=[\=\x20\r\n\t]|\xc2\xa0) \'[^\']*\'
                                       )*
                                       #incorrect attributes
                                       [^>]*+';

        if (is_array($s))
        {
            if ($_callback_type === 'strip_tags')
            {
                $tag = strtolower($s[1]);
                if ($_allowable_tags)
                {
                    #tag with attributes
                    if (array_key_exists($tag, $_allowable_tags)) return $s[0];

                    #tag without attributes
                    if (array_key_exists('<' . $tag . '>', $_allowable_tags))
                    {
                        if (substr($s[0], 0, 2) === '</') return '</' . $tag . '>';
                        if (substr($s[0], -2) === '/>')   return '<' . $tag . ' />';
                        return '<' . $tag . '>';
                    }
                }
                if ($tag === 'br') return "\r\n";
                if ($_para_tags && array_key_exists($tag, $_para_tags)) return "\r\n\r\n";
                return '';
            }
            trigger_error('Unknown callback type "' . $_callback_type . '"!', E_USER_ERROR);
        }

        if (($pos = strpos($s, '<')) === false || strpos($s, '>', $pos) === false)  #speed improve
        {
            #tags are not found
            return $s;
        }

        $length = strlen($s);

        #unpaired tags (opening, closing, !DOCTYPE, MS Word namespace)
        $re_tags = '~  <[/!]?+
                       (
                           [a-zA-Z][a-zA-Z\d]*+
                           (?>:[a-zA-Z][a-zA-Z\d]*+)?
                       ) #1
                       ' . $re_attrs_fast_safe . '
                       >
                    ~sxSX';

        $patterns = array(
            '/<([\?\%]) .*? \\1>/sxSX',  
            '/<\!\[CDATA\[ .*? \]\]>/sxSX',
    

            '/<\!--.*?-->/sSX',

            '/ <\! (?:--)?+
                   \[
                   (?> [^\]"\']+ | "[^"]*" | \'[^\']*\' )*
                   \]
                   (?:--)?+
               >
             /sxSX',
        );
        if ($pair_tags)
        {
            foreach ($pair_tags as $k => $v) $pair_tags[$k] = preg_quote($v, '/');
            $patterns[] = '/ <((?i:' . implode('|', $pair_tags) . '))' . $re_attrs_fast_safe . '(?<!\/)>
                             .*?
                             <\/(?i:\\1)' . $re_attrs_fast_safe . '>
                           /sxSX';
        }

        $i = 0;
        $max = 99;
        while ($i < $max)
        {
            $s2 = preg_replace($patterns, '', $s);
            if (preg_last_error() !== PREG_NO_ERROR)
            {
                $i = 999;
                break;
            }

            if ($i == 0)
            {
                $is_html = ($s2 != $s || preg_match($re_tags, $s2));
                if (preg_last_error() !== PREG_NO_ERROR)
                {
                    $i = 999;
                    break;
                }
                if ($is_html)
                {
                    if ($is_format_spaces)
                    {
                        $s2 = preg_replace('/  [\x09\x0a\x0c\x0d]++
                                             | <((?i:pre|textarea))' . $re_attrs_fast_safe . '(?<!\/)>
                                               .+?
                                               <\/(?i:\\1)' . $re_attrs_fast_safe . '>
                                               \K
                                            /sxSX', ' ', $s2);
                        if (preg_last_error() !== PREG_NO_ERROR)
                        {
                            $i = 999;
                            break;
                        }
                    }

                    if ($allowable_tags) $_allowable_tags = array_flip($allowable_tags);

                    if ($para_tags) $_para_tags = array_flip($para_tags);
                }
            }

            #tags processing
            if ($is_html)
            {
                $_callback_type = 'strip_tags';
                $s2 = preg_replace_callback($re_tags, __FUNCTION__, $s2);
                $_callback_type = false;
                if (preg_last_error() !== PREG_NO_ERROR)
                {
                    $i = 999;
                    break;
                }
            }

            if ($s === $s2) break;
            $s = $s2; $i++;
        }#while
        if ($i >= $max) $s = strip_tags($s); #too many cycles for replace...

        if ($is_format_spaces && strlen($s) !== $length)
        {
            #remove a duplicate spaces
            $s = preg_replace('/\x20\x20++/sSX', ' ', trim($s));
            #remove a spaces before and after new lines
            $s = str_replace(array("\r\n\x20", "\x20\r\n"), "\r\n", $s);
            #replace 3 and more new lines to 2 new lines
            $s = preg_replace('/[\r\n]{3,}+/sSX', "\r\n\r\n", $s);
        }
        return $s;
    }

?>